<?php if (!defined('PmWiki')) exit();

/*	=== Bloge: Blog group customizations ===
 *	Copyright 2009 Eemeli Aro <eemeli@gmail.com>
 *
 *	This is a part of the Bloge bundle of recipes.
 *	For more information, please see the online documentation at
 *		http://www.pmwiki.org/wiki/Cookbook/Bloge
 */

## Bloge-UrlApprove
if (IsEnabled($EnableBlogeUrlApprove,1)) include_once("$FarmD/cookbook/bloge-urlapprove.php");

## Bloge-Tags
if (IsEnabled($EnableBlogeTags,1)) include_once("$FarmD/cookbook/bloge-tags.php");

## Bloge-Feeds
if (IsEnabled($EnableBlogeFeeds,1)) {
	if (!empty($Bloge['feeds'][$action])) {
		SDVA($FeedPageListOpt, array(
			'name' => '????-??-??*',
			'order' => '-ctime',
			'count' => 10
		));
		if (preg_match('/\.\d{4}-\d{2}-\d{2}/', $pagename)
			&& !empty($Bloge['comment-group'])
			&& in_array($action, (array)$Bloge['comment-feeds'])
		) {
			$_REQUEST['group'] = $Bloge['comment-group'];
			$FeedPageListOpt['name'] = preg_replace('/^[^.]+\./', '', $pagename).'-???';
			$FeedFmt[$action]['feed']['title'] = '$WikiTitle | $Title $[comments]';
		} else {
			if (empty($_REQUEST['group'])) $_REQUEST['group'] = $Bloge['group'];
			SDV($FeedFmt['atom']['feed']['link'], "<link rel=\"self\" href=\"{$Bloge['feeds']['atom']}\" />\n");
			SDV($FeedFmt['rss']['feed']['atom:link'], "<atom:link rel=\"self\" href=\"{$Bloge['feeds']['rss']}\" />\n");
		}
		SDV($BlogeFeedSection, '##jump');

		include_once("$FarmD/cookbook/bloge-feeds.php");

		return;
	}

	function BlogeFeedHeader($type, $url, $title) {
		if (empty($url)) return '';
		switch($type) {
			case 'atom': $t = "type=\"application/atom+xml\" title=\"$[$title] (Atom)\""; break;
			case 'rss': $t = "type=\"application/rss+xml\" title=\"$[$title] (RSS 2.0)\""; break;
			default: return '';
		}
		return "\n<link rel=\"alternate\" $t href=\"$url\" />";
	}

	## blog post feed autodiscovery
	foreach ( $Bloge['feeds'] as $n => $url ) $HTMLHeaderFmt['bloge'] .= BlogeFeedHeader($n, $url, XL('Blog posts'));
}

if (!empty($Bloge['css-url'])) $HTMLHeaderFmt['bloge'] .= "\n<link rel='stylesheet' type='text/css' href='{$Bloge['css-url']}' />";
if (!empty($Bloge['javascript-url'])) $HTMLHeaderFmt['bloge'] .= "\n<script type='text/javascript' src='{$Bloge['javascript-url']}'></script>";

$PageTextVarPatterns['#jump'] = '/(\[\[#(jump))(\]\])/';

## archive pages (contents from GroupFooter)
if (preg_match('/\.\d{1,4}(?:-\d{2})?$/', $pagename)) {
	$DefaultPageTextFmt = '';
	$PageNotFoundHeaderFmt = 'HTTP/1.1 200 Ok';
	return;
}

## skip the rest for non-blog posts
if (!preg_match('/\.\d{4}-\d{2}-\d{2}/', $pagename) && ($pagename != $Bloge['newpostpage'])) return;

if (isset($_POST['author'])) $_POST['author'] = preg_replace('/\s/', '', $_POST['author']);

if ($action=='edit') {
	if (!empty($Bloge['editformpage'])) $PageEditForm = $Bloge['editformpage'];
	SDV($GUIButtons['jump'], array(490, '\\n[[#jump]]\\n', '', '', '$GUIButtonDirUrlFmt/preview.gif"$[Add jump to full post]"'));

	## Bloge-LinkbackClient
	if (IsEnabled($EnableBlogeLinkbackClient,0)) include_once("$FarmD/cookbook/bloge-linkback-client.php");

	## Bloge-Ping
	if (IsEnabled($EnableBlogePing,0)) include_once("$FarmD/cookbook/bloge-ping.php");

	## EditAttributes
	SDVA($EditAttrFields, array(
		'title' => array('attribute' => 1, 'markup' => '(:title $1:)'),
		'description' => array('attribute' => 1, 'markup' => '(:description $1:)'),
		'keywords' => array('attribute' => 1, 'markup' => '(:keywords $1:)'),
		'ctime' => array('attribute' => 1, 'filter' => 'BlogeFilterCtime'),
		'hidecomments' => array('markup' => '(:hidecomments:$1:)', 'input' => array(':html' => '<input type=\'checkbox\' $InputFormArgs />')),
		'lockcomments' => array('markup' => '(:lockcomments:$1:)', 'input' => array(':html' => '<input type=\'checkbox\' $InputFormArgs />'))
	));
	include_once("$FarmD/cookbook/editattr.php");
	$EditFields = array_merge($EditFields, array_keys($EditAttrFields));
	function BlogeFilterCtime($pagename, $fn, &$new) {
		global $Now, $MessagesFmt, $TimeFmt, $EnablePost;
		$ct = trim($new['ctime']);
		$t = empty($ct)
			? $Now
			: preg_match('/^\d{9,}$/', $ct)
				? intval($ct)
				: strtotime($ct);
		if (!$t) {
			$t = $Now;
			$MessagesFmt[] = "<h3 class='wikimessage'>$[Error parsing time:] $ct</h3>";
		}
		$new['ctime'] = $EnablePost ? $t : strftime($TimeFmt, $t);
	}
}

## comments / PmForm
if (IsEnabled($EnableBlogeComments,1) && !empty($Bloge['comment-group']) && !empty($Bloge['templatepage'])) {
	## comment feed autodiscovery
	if (IsEnabled($EnableBlogeFeeds,1) && !empty($Bloge['comment-feeds'])) foreach ( (array)$Bloge['comment-feeds'] as $feed ) {
		$HTMLHeaderFmt['bloge'] .= BlogeFeedHeader($feed,
			PageVar($pagename, '$PageUrl')."?action=$feed",
			XL('Comments on this post'));
	}

	## use #postcomment anchor to scroll down the result page
	SDV($InputTags['pmform'][':html'],
		"<form action='{\$PageUrl}#postcomment' \$InputFormArgs><input type='hidden' name='n' value='{\$FullName}' /><input type='hidden' name='action' value='pmform' />");

	$PmForm['comments'] = "form={$Bloge['templatepage']}#commentform fmt={$Bloge['templatepage']}#commentpost";
	include_once("$FarmD/cookbook/pmform.php");

	if ($action=='pmform') {
		if (!empty($Bloge['comment-blocklist'])) {
			$EnableBlocklist = $Bloge['comment-blocklist'];
			include_once("$FarmD/scripts/blocklist.php");
			BlockList($pagename, @$_POST['msg']);
			if (!$EnablePost) Abort(XL('Comment blocked.'));
		}

		if (empty($AuthId)) $PmForm['comments'] .= ' users="-'.implode(',-',(array)BlogeAuthUserList($pagename)).'"';
		else $PmForm['comments'] .= ' users=*';

		function BlogeMakeNewCommentPageName($pagename, $commentgroup) {
			$name = preg_replace('#^.+[./]([^./]+)$#', '$1', $pagename);
			$ls = ListPages("/^$commentgroup\.$name-\\d/");
			$ci = 0;
			foreach ( $ls as $cp ) $ci = max( $ci, substr( $cp, strrpos($cp,'-')+1 ) );
			return "$commentgroup.$name-".sprintf('%03d',$ci+1);
		}
		$PmForm['comments'] .= ' saveto='.BlogeMakeNewCommentPageName($pagename, $Bloge['comment-group']);

		if (!empty($Bloge['email-to']))
			$PmForm['comments'] .= " mailto=\"{$Bloge['email-to']}\" from=\"{$Bloge['email-from']}\" subject=\"{$Bloge['email-subject']}\"";

		## HACK: $pagename is different in PmFormSave & PmFormMail, so using
		## that to get a link to the post in the email via {$$BlogePostUrl}
		$FmtPV['$BlogePostUrl'] = 'BlogePostUrl($group,$name)';
		function BlogePostUrl($group, $name) {
			global $Bloge, $ScriptUrl;
			return ($group==$Bloge['group']) ? "$ScriptUrl/$group/$name\n\n" : '';
		}
	}

	if (IsEnabled($EnableAuthorTracking,1)) {
		include_once("$FarmD/scripts/author.php");
		if (empty($Author)) $Author = '$[Anonymous]';
	}
}

